<?php

    class PHP_Script_Evaluation_Action extends Reactor_Action
    {
        protected $tpl = 'php_script_evaluation.php';
        protected $name = 'Run a PHP script';
		
		public static $registration = array(
			ACTION_NAME => 'Run a PHP script',
			ACTION_CATEGORY => 'Code Evaluation',
			ACTION_DESCRIPTION => 'Evaluates a block of custom PHP code',
			ACTION_AUTHOR => 'Jeremy Yunis, Nagios Enterprises, LLC',
			ACTION_VERSION => '1.0',
			ACTION_DATE => '01/22/2013', //Last version update
			ACTION_AUTHLEVEL => 0,  // 0 - everyone | 1 - Admin only
			ACTION_TYPE => 'core', //core | user. core modules can't be deleted
			ACTION_META => array(),	//Misc information	
		); 
		
        protected $fields = array(
            'script' => array(
                'label' => 'PHP script',
                'validate' => 'trim|required|callback_strip_php_tags'
            ),
        );

        public function strip_php_tags($str)
        {
            return preg_replace('/&lt;\?php/i', '',
                preg_replace('/\?&gt;/', '', $str));
        }

        public function run($context)
        {
            $this->set_context($context);
            $params = $this->get_params();
            $script = $params['script'];
            list($cmd_out_arr, $cmd_status) = do_eval_php($script); 
            $cmd_out = implode("\n", $cmd_out_arr);
            $this->log('info', "got output: ".$cmd_out);
            $this->log('info', "cmd exit status: ".$cmd_status);
            $this->set_result($cmd_status);
            return $context;
        }
    }
